/*
Slow Walsh transform

x - pointer to input data
y - pointer to output data
n - order (number of data points)

(c)VLV
*/


#include "walsh.h"


void WT(int *x,int *y,int n)
{
int i,j,s;
double dQ;

dQ=1.0/((double)n);

for(i=0;i<n;i++)
 {
 s=0;
 for(j=0;j<n;j++)
  {
  if(walsh(i,dQ*j)) s+=x[j];
  else s-=x[j];
  }
 y[i]=s;
 }
}

